diff --git a/src/main/java/net/minecraft/client/gui/paged/GuiPaged.java b/src/main/java/net/minecraft/client/gui/paged/GuiPaged.java
new file mode 100644
index 000000000..3ab1e68cb
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/paged/GuiPaged.java
@@ -0,0 +1,472 @@
+package net.minecraft.client.gui.paged;
+
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiRenderItem;
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.render.Scissor;
+import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.sound.SoundCategory;
+import org.lwjgl.input.Keyboard;
+import org.lwjgl.input.Mouse;
+import org.lwjgl.opengl.GL11;
+
+import static org.lwjgl.opengl.GL11.*;
+import static org.lwjgl.opengl.GL11.GL_TEXTURE_2D;
+
+public class GuiPaged
+    extends GuiScreen {
+    private static final int TOP_SPACING = 24;
+    private static final int BUTTON_SPACING = 4;
+    private static final int SEPARATOR_WIDTH = 8;
+    private static final int PADDING = 8;
+    private static final int PAGE_BUTTON_HEIGHT = 20;
+
+    private float rightScrollAmount = 0.0f;
+    private float leftScrollAmount = 0.0f;
+    private int top, bottom, rightScrollRegionHeight, leftScrollRegionHeight, pageWidth, leftWidth;
+
+    private Float oldRightScrollAmount;
+    private Float oldLeftScrollAmount;
+    private Integer clickX, clickY;
+    private Page selectedPage;
+    private PageComponent clickedComponent;
+    private int clickedComponentY;
+    private GuiRenderItem renderItem = null;
+
+    private final PageRegistry pageRegistry;
+
+    public GuiPaged(GuiScreen parent, PageRegistry pageRegistry, Page selectedPage)
+    {
+        super(parent);
+        this.pageRegistry = pageRegistry;
+        this.selectedPage = selectedPage;
+    }
+
+    @Override
+    public void init()
+    {
+        super.init();
+
+        controlList.add(new GuiButton(0, width / 2 - 100, height - (BUTTON_SPACING + 20), 200, 20, I18n.getInstance().translateKey("gui.options.button.done")));
+
+        top = TOP_SPACING;
+        bottom = height - (BUTTON_SPACING + 20 + BUTTON_SPACING);
+
+        rightScrollRegionHeight = bottom - top;
+        leftScrollRegionHeight = bottom - top;
+
+        this.renderItem = new GuiRenderItem(mc);
+
+        this.selectedPage.initComponents(mc);
+    }
+
+    @Override
+    public void keyTyped(char c, int key, int mouseX, int mouseY) {
+        if (key == Keyboard.KEY_ESCAPE)
+        {
+            mc.displayGuiScreen(getParentScreen());
+        }
+        else
+        {
+            for (PageComponent component : selectedPage.getComponents())
+            {
+                component.onKeyPress(key, c);
+            }
+        }
+    }
+
+    private void drawPageItems(int x, int y, int width, int mouseX, int mouseY)
+    {
+        int y2 = y;
+        for (PageComponent component : selectedPage.getComponents())
+        {
+            component.render(x, y2, width, mouseX - x, mouseY - y2);
+            y2 += component.getHeight();
+        }
+    }
+
+    private void drawPagesListItems(int x, int y, int width, int mouseX, int mouseY) {
+        int y2 = y;
+        for(Page page : pageRegistry.getPages()) {
+            String translated = I18n.getInstance().translateKey(page.getTranslationKey());
+            int textColor = 0xFF7F7F7F;
+            if (page == selectedPage) {
+                textColor = 0xFFFFFFFF;
+            }
+            if (mouseX >= x && mouseX < x + width && mouseY >= y2 && mouseY < y2 + PAGE_BUTTON_HEIGHT) {
+                textColor = 0xFFFFFFA0;
+            }
+            renderItem.render(page.getIcon(), x, y2 + (PAGE_BUTTON_HEIGHT / 2) - 9);
+            mc.fontRenderer.drawStringWithShadow(translated, x + 19, y2 + (PAGE_BUTTON_HEIGHT / 2) - 4, textColor);
+            y2 += PAGE_BUTTON_HEIGHT;
+        }
+    }
+
+    @Override
+    public void tick() {
+        for (PageComponent component : selectedPage.getComponents())
+        {
+            component.tick();
+        }
+    }
+
+    @Override
+    protected void buttonPressed(GuiButton guibutton) {
+        super.buttonPressed(guibutton);
+
+        if (guibutton.id == 0)
+        {
+            mc.displayGuiScreen(getParentScreen());
+            mc.texturePackList.refreshIfReady(); // Sets the texturepacks on menu close
+        }
+    }
+
+    @Override
+    public void onClosed() {
+        super.onClosed();
+        mc.gameSettings.saveOptions();
+    }
+
+    private void scrollOptions(float amount) {
+        if(amount == 0.0f) return;
+
+        rightScrollAmount += amount;
+        onScrollOptions();
+    }
+
+    private void onScrollOptions() {
+        int totalPageHeight = getTotalPageHeight();
+        if (rightScrollAmount < 0 || rightScrollRegionHeight > totalPageHeight) rightScrollAmount = 0;
+        else if (rightScrollAmount > totalPageHeight - rightScrollRegionHeight) rightScrollAmount = totalPageHeight - rightScrollRegionHeight;
+    }
+
+    private void scrollPagesList(float amount) {
+        if(amount == 0.0f) return;
+
+        leftScrollAmount += amount;
+        onScrollPagesList();
+    }
+
+    private void onScrollPagesList() {
+        int totalPagesListHeight = getTotalPagesListHeight();
+        if (leftScrollAmount < 0 || leftScrollRegionHeight > totalPagesListHeight) leftScrollAmount = 0;
+        else if (leftScrollAmount > totalPagesListHeight - leftScrollRegionHeight) leftScrollAmount = totalPagesListHeight - leftScrollRegionHeight;
+    }
+
+    private int getTotalPageHeight()
+    {
+        int totalPageHeight = 0;
+        for (PageComponent component : selectedPage.getComponents())
+        {
+            totalPageHeight += component.getHeight();
+        }
+        return totalPageHeight;
+    }
+
+    private int getTotalPagesListHeight() {
+        return PAGE_BUTTON_HEIGHT * pageRegistry.getPages().size();
+    }
+
+    @Override
+    public void drawScreen(int mouseX, int mouseY, float renderPartialTicks)
+    {
+        if (mouseX > leftWidth + SEPARATOR_WIDTH + PADDING && mouseX < width) {
+            if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
+                scrollOptions(Mouse.getDWheel() * -1.0f);
+            } else {
+                scrollOptions(Mouse.getDWheel() / -5.0f);
+            }
+            onScrollOptions();
+        } else if (mouseX >= 0 && mouseX <= leftWidth) {
+            if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
+                scrollPagesList(Mouse.getDWheel() * -1.0f);
+            } else {
+                scrollPagesList(Mouse.getDWheel() / -5.0f);
+            }
+            onScrollPagesList();
+        }
+
+        leftWidth = (int)(width * 0.25f);
+        pageWidth = width - (leftWidth + SEPARATOR_WIDTH + (PADDING * 2));
+        I18n i18n = I18n.getInstance();
+
+        drawDefaultBackground();
+        overlayBackground(0, width, 0, top);
+        overlayBackground(0, width, bottom, height);
+
+        Scissor.enable(0, top, width, bottom - top);
+        if (mouseY >= top && mouseY <= bottom) {
+            drawPageItems(leftWidth + SEPARATOR_WIDTH + PADDING, top - (int) rightScrollAmount, pageWidth - 8, mouseX, mouseY);
+        } else {
+            drawPageItems(leftWidth + SEPARATOR_WIDTH + PADDING, top - (int) rightScrollAmount, pageWidth - 8, -1, -1);
+        }
+        Scissor.disable();
+
+        Scissor.enable(0, top, leftWidth, bottom - top);
+        int pagesListHeight = getTotalPagesListHeight();
+        int pagesListY = top - (int) leftScrollAmount;
+        if (pagesListHeight < bottom - top) {
+            pagesListY = top + (bottom - top - pagesListHeight) / 2;
+        }
+        if (mouseY >= top && mouseY <= bottom) {
+            drawPagesListItems(PADDING - 4, pagesListY, leftWidth - PADDING, mouseX, mouseY);
+        } else {
+            drawPagesListItems(PADDING - 4, pagesListY, leftWidth - PADDING, -1, -1);
+        }
+        Scissor.disable();
+
+        // Draw shadows
+        if (mc.theWorld == null)
+        {
+            TessellatorStandard tessellator = TessellatorStandard.instance;
+            GL11.glDisable(GL_DEPTH_TEST);
+            int shadowSize = 4;
+            GL11.glEnable(GL_BLEND);
+            GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+            GL11.glDisable(GL_ALPHA_TEST);
+            GL11.glShadeModel(GL_SMOOTH);
+            GL11.glDisable(GL_TEXTURE_2D);
+
+            tessellator.startDrawingQuads();
+            tessellator.setColorRGBA_I(0, 0);
+            tessellator.addVertexWithUV(0, top + shadowSize, 0.0D, 0.0D, 1.0D);
+            tessellator.addVertexWithUV(width, top + shadowSize, 0.0D, 1.0D, 1.0D);
+            tessellator.setColorRGBA_I(0, 255);
+            tessellator.addVertexWithUV(width, top, 0.0D, 1.0D, 0.0D);
+            tessellator.addVertexWithUV(0, top, 0.0D, 0.0D, 0.0D);
+            tessellator.draw();
+
+            tessellator.startDrawingQuads();
+            tessellator.setColorRGBA_I(0, 255);
+            tessellator.addVertexWithUV(0, bottom, 0.0D, 0.0D, 1.0D);
+            tessellator.addVertexWithUV(width, bottom, 0.0D, 1.0D, 1.0D);
+            tessellator.setColorRGBA_I(0, 0);
+            tessellator.addVertexWithUV(width, bottom - shadowSize, 0.0D, 1.0D, 0.0D);
+            tessellator.addVertexWithUV(0, bottom - shadowSize, 0.0D, 0.0D, 0.0D);
+            tessellator.draw();
+
+            GL11.glEnable(GL_TEXTURE_2D);
+            GL11.glShadeModel(GL_FLAT);
+            GL11.glEnable(GL_ALPHA_TEST);
+            GL11.glDisable(GL_BLEND);
+        }
+
+        overlayBackground(leftWidth, leftWidth + SEPARATOR_WIDTH, top, bottom);
+
+        String titleLanguageKey = "gui.options.title";
+        drawStringCentered(fontRenderer, i18n.translateKey(titleLanguageKey), width / 2, 5, 0xffffff);
+
+        drawOptionsScrollBar(mouseX, mouseY);
+        drawPagesListScrollBar(mouseX, mouseY);
+
+        super.drawScreen(mouseX, mouseY, renderPartialTicks);
+    }
+
+    protected void drawOptionsScrollBar(int mouseX, int mouseY) {
+        float totalPageHeight = getTotalPageHeight();
+        float scrollBarHeightPercent = rightScrollRegionHeight / totalPageHeight;
+
+        if(scrollBarHeightPercent > 1.0f) return;
+
+        glDisable(GL_TEXTURE_2D);
+
+        int scrollBarX = width - 6;
+
+        int scrollBarHeightPx = (int) (scrollBarHeightPercent * rightScrollRegionHeight);
+        if(scrollBarHeightPx < 32) {
+            scrollBarHeightPx = 32;
+        }
+
+        float scrollPercent = rightScrollAmount / (totalPageHeight - rightScrollRegionHeight);
+
+        int scrollBarY = (int) (top + (rightScrollRegionHeight - scrollBarHeightPx) * scrollPercent);
+
+        TessellatorStandard t = TessellatorStandard.instance;
+
+        t.startDrawingQuads();
+        t.setColorOpaque(0, 0, 0);
+        t.drawRectangle(scrollBarX, top, 6, rightScrollRegionHeight);
+        t.setColorRGBA_I(0x808080, 255);
+        t.drawRectangle(scrollBarX, scrollBarY, 6, scrollBarHeightPx);
+        t.setColorRGBA_I(0xc0c0c0, 255);
+        t.drawRectangle(scrollBarX + 1, scrollBarY, 5, scrollBarHeightPx - 1);
+        t.draw();
+
+        glEnable(GL_TEXTURE_2D);
+
+        if(clickX != null && clickY != null) {
+            if(clickX >= scrollBarX && clickY >= top && clickX <= scrollBarX + 6 && clickY < bottom) {
+                if(oldRightScrollAmount == null) {
+                    oldRightScrollAmount = rightScrollAmount;
+                }
+                rightScrollAmount = oldRightScrollAmount + (clickY - mouseY) * (1.0f / scrollBarHeightPercent) * -1.0f;
+                onScrollOptions();
+            }
+        }else {
+            oldRightScrollAmount = null;
+        }
+    }
+
+    protected void drawPagesListScrollBar(int mouseX, int mouseY) {
+        float totalPagesListHeight = getTotalPagesListHeight();
+        float scrollBarHeightPercent = leftScrollRegionHeight / totalPagesListHeight;
+
+        if(scrollBarHeightPercent > 1.0f) return;
+
+        glDisable(GL_TEXTURE_2D);
+
+        int scrollBarX = leftWidth - 6;
+
+        int scrollBarHeightPx = (int) (scrollBarHeightPercent * leftScrollRegionHeight);
+        if(scrollBarHeightPx < 32) {
+            scrollBarHeightPx = 32;
+        }
+
+        float scrollPercent = leftScrollAmount / (totalPagesListHeight - leftScrollRegionHeight);
+
+        int scrollBarY = (int) (top + (leftScrollRegionHeight - scrollBarHeightPx) * scrollPercent);
+
+        TessellatorStandard t = TessellatorStandard.instance;
+
+        t.startDrawingQuads();
+        t.setColorOpaque(0, 0, 0);
+        t.drawRectangle(scrollBarX, top, 6, leftScrollRegionHeight);
+        t.setColorRGBA_I(0x808080, 255);
+        t.drawRectangle(scrollBarX, scrollBarY, 6, scrollBarHeightPx);
+        t.setColorRGBA_I(0xc0c0c0, 255);
+        t.drawRectangle(scrollBarX + 1, scrollBarY, 5, scrollBarHeightPx - 1);
+        t.draw();
+
+        glEnable(GL_TEXTURE_2D);
+
+        if(clickX != null && clickY != null) {
+            if(clickX >= scrollBarX && clickY >= top && clickX <= scrollBarX + 6 && clickY < bottom) {
+                if(oldLeftScrollAmount == null) {
+                    oldLeftScrollAmount = leftScrollAmount;
+                }
+                leftScrollAmount = oldLeftScrollAmount + (clickY - mouseY) * (1.0f / scrollBarHeightPercent) * -1.0f;
+                onScrollOptions();
+            }
+        }else {
+            oldLeftScrollAmount = null;
+        }
+    }
+
+    @Override
+    public void mouseClicked(int mouseX, int mouseY, int mouseButton)
+    {
+        super.mouseClicked(mouseX, mouseY, mouseButton);
+
+        int left = leftWidth + SEPARATOR_WIDTH + PADDING;
+
+        if (mouseX >= leftWidth + SEPARATOR_WIDTH && mouseY >= top && mouseY <= bottom) {
+            int componentY = top - (int) rightScrollAmount;
+            for (PageComponent component : selectedPage.getComponents())
+            {
+                if (mouseX >= left && mouseX <= left + pageWidth - PADDING && mouseY >= componentY && mouseY <= componentY + component.getHeight()) {
+                    component.onMouseClick(mouseButton, left, componentY, pageWidth - PADDING, mouseX - left, mouseY - componentY);
+                    clickedComponent = component;
+                    clickedComponentY = componentY;
+                    break;
+                }
+                componentY += component.getHeight();
+            }
+        } else if (mouseX >= 0 && mouseX <= leftWidth && mouseY >= top && mouseY <= bottom) {
+            int pagesListHeight = getTotalPagesListHeight();
+            int pagesListY = top - (int) leftScrollAmount;
+            if (pagesListHeight < bottom - top) {
+                pagesListY = top + (bottom - top - pagesListHeight) / 2;
+            }
+            for(Page page : pageRegistry.getPages()) {
+                if (mouseX >= 0 && mouseX <= leftWidth && mouseY >= pagesListY && mouseY <= pagesListY + PAGE_BUTTON_HEIGHT) {
+                    rightScrollAmount = 0;
+                    selectedPage = page;
+                    this.selectedPage.initComponents(mc);
+                    mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
+                    mc.texturePackList.refreshIfReady();
+                    break;
+                }
+                pagesListY += PAGE_BUTTON_HEIGHT;
+            }
+        }
+
+        clickX = mouseX;
+        clickY = mouseY;
+    }
+
+    @Override
+    public void mouseMovedOrButtonReleased(int mouseX, int mouseY, int mouseButton) {
+        super.mouseMovedOrButtonReleased(mouseX, mouseY, mouseButton);
+
+        int left = leftWidth + SEPARATOR_WIDTH + PADDING;
+        if (mouseY >= top && mouseY <= bottom) {
+            if (clickedComponent != null) {
+                if (mouseButton >= 0) {
+                    clickedComponent.onMouseRelease(mouseButton, left, clickedComponentY, pageWidth, mouseX - left, mouseY - clickedComponentY);
+                    clickedComponent = null;
+                } else {
+                    clickedComponent.onMouseMove(left, clickedComponentY, pageWidth, mouseX - left, mouseY - clickedComponentY);
+                }
+            }
+        }
+
+        if(mouseButton >= 0) {
+            clickX = null;
+            clickY = null;
+        }
+    }
+
+    @Override
+    public void drawDefaultBackground() {
+        super.drawDefaultBackground();
+
+        if (mc.theWorld == null)
+        {
+            TessellatorStandard tessellator = TessellatorStandard.instance;
+            GL11.glBindTexture(GL_TEXTURE_2D, mc.renderEngine.getTexture("/gui/background.png"));
+            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+            float scale = 32F;
+            tessellator.startDrawingQuads();
+            tessellator.setColorOpaque_I(0x202020);
+
+            tessellator.addVertexWithUV(0, bottom, 0.0D, 0, (float)(bottom + (int) rightScrollAmount) / scale);
+            tessellator.addVertexWithUV(width, bottom, 0.0D, (float)width / scale, (float)(bottom + (int) rightScrollAmount) / scale);
+            tessellator.addVertexWithUV(width, top, 0.0D, (float)width / scale, (float)(top + (int) rightScrollAmount) / scale);
+            tessellator.addVertexWithUV(0, top, 0.0D, 0, (float)(top + (int) rightScrollAmount) / scale);
+
+            tessellator.addVertexWithUV(0, bottom, 0.0D, 0, (float)(bottom + (int) leftScrollAmount) / scale);
+            tessellator.addVertexWithUV(leftWidth, bottom, 0.0D, (float) leftWidth / scale, (float)(bottom + (int) leftScrollAmount) / scale);
+            tessellator.addVertexWithUV(leftWidth, top, 0.0D, (float) leftWidth / scale, (float)(top + (int) leftScrollAmount) / scale);
+            tessellator.addVertexWithUV(0, top, 0.0D, 0, (float)(top + (int) leftScrollAmount) / scale);
+
+            tessellator.draw();
+        }
+        else
+        {
+            drawRect(0, 0, width, top, 0x5F000000);
+            drawRect(0, bottom, width, height, 0x5F000000);
+            drawRect(leftWidth, top, leftWidth + SEPARATOR_WIDTH, bottom, 0x5F000000);
+        }
+    }
+
+    private void overlayBackground(int minX, int maxX, int minY, int maxY)
+    {
+        if (mc.theWorld == null)
+        {
+            TessellatorStandard tessellator = TessellatorStandard.instance;
+            GL11.glBindTexture(GL_TEXTURE_2D, mc.renderEngine.getTexture("/gui/background.png"));
+            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+            float scale = 32F;
+            tessellator.startDrawingQuads();
+            tessellator.setColorOpaque_I(0x404040);
+            tessellator.addVertexWithUV(minX, maxY, 0.0D, (float) minX / scale, (float) maxY / scale);
+            tessellator.addVertexWithUV(maxX, maxY, 0.0D, (float) maxX / scale, (float) maxY / scale);
+            tessellator.setColorOpaque_I(0x404040);
+            tessellator.addVertexWithUV(maxX, minY, 0.0D, (float) maxX / scale, (float) minY / scale);
+            tessellator.addVertexWithUV(minX, minY, 0.0D, (float) minX / scale, (float) minY / scale);
+            tessellator.draw();
+        }
+    }
+
+}
diff --git a/src/main/java/net/minecraft/client/gui/paged/Page.java b/src/main/java/net/minecraft/client/gui/paged/Page.java
new file mode 100644
index 000000000..f2fa2f343
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/paged/Page.java
@@ -0,0 +1,59 @@
+package net.minecraft.client.gui.paged;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.options.components.OptionsComponent;
+import net.minecraft.client.gui.options.data.OptionsPage;
+import net.minecraft.core.item.ItemStack;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class Page {
+    private static final int COMPONENT_SPACING = 4;
+    private final String translationKey;
+    private final List<PageComponent> components = new ArrayList<>();
+    private final ItemStack icon;
+
+    public Page(String translationKey, ItemStack icon) {
+        this.translationKey = translationKey;
+        this.icon = icon;
+    }
+
+    public Page withComponent(PageComponent component)
+    {
+        components.add(component);
+        return this;
+    }
+
+    public String getTranslationKey()
+    {
+        return translationKey;
+    }
+
+    public List<PageComponent> getComponents()
+    {
+        return components;
+    }
+
+    public void initComponents(Minecraft mc) {
+        for (PageComponent component : components) {
+            component.init(mc);
+        }
+    }
+
+    public int getHeight()
+    {
+        int height = 0;
+        for (PageComponent component : components)
+        {
+            height += component.getHeight() + COMPONENT_SPACING;
+        }
+        height -= COMPONENT_SPACING;
+        return height;
+    }
+
+    public ItemStack getIcon()
+    {
+        return icon;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/paged/PageComponent.java b/src/main/java/net/minecraft/client/gui/paged/PageComponent.java
new file mode 100644
index 000000000..8301b293e
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/paged/PageComponent.java
@@ -0,0 +1,23 @@
+package net.minecraft.client.gui.paged;
+
+import net.minecraft.client.Minecraft;
+
+public interface PageComponent {
+    default void init(Minecraft mc) { }
+
+    int getHeight();
+
+    void render(int x, int y, int width, int relativeMouseX, int relativeMouseY);
+
+    default void tick() { }
+
+    void onMouseClick(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY);
+
+    void onMouseMove(int x, int y, int width, int relativeMouseX, int relativeMouseY);
+
+    void onMouseRelease(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY);
+
+    void onKeyPress(int keyCode, char character);
+
+    boolean matchesSearchTerm(String term);
+}
diff --git a/src/main/java/net/minecraft/client/gui/paged/PageRegistry.java b/src/main/java/net/minecraft/client/gui/paged/PageRegistry.java
new file mode 100644
index 000000000..c38e82dcf
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/paged/PageRegistry.java
@@ -0,0 +1,23 @@
+package net.minecraft.client.gui.paged;
+
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.List;
+
+public class PageRegistry {
+    private final List<Page> pages = new ArrayList<>();
+
+    public void register(Page page) {
+        if (!pages.contains(page)) {
+            pages.add(page);
+        }
+    }
+
+    public int getPageIndex(Page page) {
+        return pages.indexOf(page);
+    }
+
+    public List<Page> getPages() {
+        return Collections.unmodifiableList(pages);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/net/handler/NetPingHandler.java b/src/main/java/net/minecraft/client/net/handler/NetPingHandler.java
index d03cd5491..810b0601d 100644
--- a/src/main/java/net/minecraft/client/net/handler/NetPingHandler.java
+++ b/src/main/java/net/minecraft/client/net/handler/NetPingHandler.java
@@ -2,6 +2,7 @@ package net.minecraft.client.net.handler;
 
 import net.minecraft.client.gui.GuiSelectServer;
 import net.minecraft.core.net.NetworkManager;
+import net.minecraft.core.net.ServerAddress;
 import net.minecraft.core.net.ServerData;
 import net.minecraft.core.net.handler.NetHandler;
 import net.minecraft.core.net.packet.Packet;
@@ -24,7 +25,8 @@ public class NetPingHandler
         throws IOException {
         this.gui = gui;
         this.server = server;
-        Socket socket = new Socket(InetAddress.getByName(server.getHostName()), server.getPort());
+        ServerAddress address = server.getServerAddress();
+        Socket socket = new Socket(InetAddress.getByName(address.getIP()), address.getPort());
         netManager = new NetworkManager(socket, "Ping", this, true);
     }
 
diff --git a/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java b/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
index 7530c497c..4e7b5fe75 100644
--- a/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
+++ b/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
@@ -3,6 +3,7 @@ package net.minecraft.client.net.thread;
 import net.minecraft.client.gui.GuiSelectServer;
 import net.minecraft.client.net.handler.NetPingHandler;
 import net.minecraft.core.Global;
+import net.minecraft.core.net.ServerAddress;
 import net.minecraft.core.net.ServerData;
 import net.minecraft.core.net.handler.NetHandler;
 import net.minecraft.core.net.packet.Packet254PingHandshake;
@@ -18,7 +19,8 @@ public class ThreadPingServer
     public ThreadPingServer(GuiSelectServer gui, ServerData server) {
         this.gui = gui;
         this.server = server;
-        this.setName("ThreadPingServer - " + server.getHostName() + ":" + server.getPort());
+        ServerAddress address = server.getServerAddress();
+        this.setName("ThreadPingServer - " + address.getIP() + ":" + address.getPort());
     }
 
     public ServerData getServer() {
@@ -39,8 +41,9 @@ public class ThreadPingServer
 
     @Override
     public void run() {
-        String hostName = server.getHostName();
-        int port = server.getPort();
+        ServerAddress address = this.server.getServerAddress();
+        String hostName = address.getIP();
+        int port = address.getPort();
 
         try {
             netHandler = new NetPingHandler(gui, server);
diff --git a/src/main/java/net/minecraft/client/option/GameSettings.java b/src/main/java/net/minecraft/client/option/GameSettings.java
index b5ee6a146..dbce20936 100644
--- a/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -107,7 +107,7 @@ public class GameSettings {
 	public EnumOption<Difficulty> difficulty = new EnumOption<>(this, "difficulty", Difficulty.class, Difficulty.NORMAL);
 	public IntegerOption thirdPersonView = new IntegerOption(this, "thirdPersonView", 0);
 	public EnumOption<RenderDistance> renderDistance = new EnumOption<>(this, "renderDistance", RenderDistance.class, RenderDistance.FAR);
-	public RangeOption limitFramerate = new RangeOption(this, "limitFramerate", 1, 4);
+	public BooleanOption enableVsync = new BooleanOption(this, "enableVsync", false);
 	public RangeOption customFpsLimit = new RangeOption(this,"customFpsLimit",0,241);
 	public IntegerOption guiScale = new IntegerOption(this, "guiScale", 0);
 	public IntegerOption overlayMode = new IntegerOption(this, "overlayMode", 0);
@@ -293,27 +293,14 @@ public class GameSettings {
 				return guiScale.value + "x";
 			}
 		}
-		if (option == limitFramerate) {
-			return trans.translateKey(LIMIT_FRAMERATES[limitFramerate.value]);
-		}
 		if(option == customFpsLimit){
 			Option<Integer> limit = (Option<Integer>) option;
 			int value = limit.value;
 			int maxValue = 240;
-			switch (limitFramerate.value) {
-				case 0:
-					break;
-				case 1:
-					maxValue = 120;
-					break;
-				case 2:
-					maxValue = 40;
-					break;
-				case 3:
-					if(mc.gameWindow instanceof GameWindowLWJGL2){
-						maxValue = ((GameWindowLWJGL2) mc.gameWindow).defaultDisplayMode.getFrequency();
-					}
-					break;
+			if (enableVsync.value){
+				if(mc.gameWindow instanceof GameWindowLWJGL2){
+					return String.valueOf(((GameWindowLWJGL2) mc.gameWindow).defaultDisplayMode.getFrequency());
+				}
 			}
 			if(value > maxValue){
 				limit.set(maxValue);
@@ -369,7 +356,7 @@ public class GameSettings {
 	}
 
 	public void optionChanged(Option<?> option) {
-		if(option == limitFramerate) Display.setVSyncEnabled(limitFramerate.value == 3);
+		if(option == enableVsync) Display.setVSyncEnabled(enableVsync.value);
 		if(option == fancyGraphics) mc.renderGlobal.loadRenderers();
 		if(option == ambientOcclusion) mc.renderGlobal.loadRenderers();
 		if(option == advancedOpenGL) mc.renderGlobal.loadRenderers();
diff --git a/src/main/java/net/minecraft/client/player/controller/PlayerController.java b/src/main/java/net/minecraft/client/player/controller/PlayerController.java
index c6f09f4ca..d03fcf2b3 100644
--- a/src/main/java/net/minecraft/client/player/controller/PlayerController.java
+++ b/src/main/java/net/minecraft/client/player/controller/PlayerController.java
@@ -36,7 +36,7 @@ public abstract class PlayerController {
 			swingItem(true);
 			
 			ItemStack heldItem = mc.thePlayer.getCurrentEquippedItem();
-			if(heldItem != null && heldItem.getItem().hasTag(ItemTags.preventCreativeMining)) {
+			if(heldItem != null && heldItem.getItem().hasTag(ItemTags.PREVENT_CREATIVE_MINING)) {
 				return;
 			}
 			
diff --git a/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java b/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
index 74ee6bf42..8a72d7ce2 100644
--- a/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
@@ -22,6 +22,7 @@ public class TileEntityRenderDispatcher
         renderers.put(TileEntityMobSpawner.class, new TileEntityRendererMobSpawner());
         renderers.put(TileEntityPistonMoving.class, new TileEntityRendererPiston());
         renderers.put(TileEntityFlowerJar.class, new TileEntityRendererFlowerJar());
+        renderers.put(TileEntityMeshGold.class, new TileEntityRendererMesh());
 
         for (TileEntityRenderer<?> tileEntityRenderer : renderers.values())
         {
